# Название:      Круг от края
# Сайт:            http://stroyka.in 
# Дата:           16.05.2011  
# Автор:         Sahi (г.Рязань)
# Описание:  Скрипт рисует окружность от края.
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=#
                                          
class Risuem_krug_otkraya
                                          
   def initialize
     @@segment = 24 if not defined? @@segment
     cursor = Sketchup.find_support_file("cursor.png","Plugins/krug_Icons/")	
		 @@cursor = UI::create_cursor(cursor, 1, 24)
  end
 # -------             # -------               # -------
 def onSetCursor
	 UI::set_cursor(@@cursor)
end
# -------             # -------               # -------
  def create_krug_otkraya
    
     model=Sketchup.active_model
     numm = Sketchup.version.to_i
     model.start_operation("Circle >>>", true) if(numm > 6 )
     model.start_operation("Circle >>>") if(numm < 6 )
     entities=model.active_entities
     
     curve = entities.add_curve @ptt
     curve.each{|edg| edg.find_faces if edg.is_a? Sketchup::Edge}
     Sketchup.active_model.commit_operation
     #Sketchup.active_model.select_tool(nil)
     self.reset
  end
# -------             # -------               # -------
def increment_state
    @state += 1
    case @state
    when 1
      @ip1.copy! @ip
      Sketchup::set_status_text "Specify the end point of the circle ©" # "Укажите конечную точку окружности ©"
    when 2
      @pts[1] = @pts[0].offset(@yvec, @length)
      @pts[2] = @pts[0].offset(@yvec, @length/2)
      @ptt = Array.new
      @ptt[0] = @pts[0]
      trans  = Geom::Transformation.rotation(@pts[2],@zvec,@angle.degrees)
      0.upto(@@segment.to_i){@ptt.push @ptt.last.transform(trans)}
      self.create_krug_otkraya
    end
  end
 # -------             # -------               # ------- 
def getExtents
   bbox = Geom::BoundingBox.new
   bbox.add(@ip.position)if @ip and @ip.valid?
   bbox.add(@pts) if @pts[1] != nil
   return bbox
 end
 # -------             # -------               # -------
  def reset
     @ip = Sketchup::InputPoint.new
     @ip1 = Sketchup::InputPoint.new
     @drawn = false
     @pts = Array.new
     @state = 0
     @angle = nil
      Sketchup::set_status_text "Sides ", SB_VCB_LABEL  # "Сегментов "
      Sketchup::set_status_text @@segment.to_s, SB_VCB_VALUE
     Sketchup::set_status_text("Set the parameters of the circle (the number of segments) ©", SB_PROMPT)  # ("Задайте параметры круга (количество сегментов) ©"
    end
# ========================================= #                                               
  def activate
    self.reset
  end
# ========================================= #                                                 
  def deactivate(view)
    view.invalidate if @drawn
    Sketchup.active_model.commit_operation
    Sketchup.active_model.select_tool(nil)
  end
# ========================================= #
  def set_current_point(x, y, view)
    if( !@ip.pick(view, x, y, @ip1) )
      return false
    end
    view.tooltip = @ip.tooltip
    ph=view.pick_helper
    ph.do_pick x,y
    sel = ph.path_at(0)

    view.tooltip = @ip.tooltip
  case @state
  when 0
  if(sel)
    if(sel[0].kind_of?(Sketchup::Face))
      #planes = sel[0].plane
      @zvec = sel[0].normal
      elsif(sel[1].kind_of?(Sketchup::Face))
       #planes = sel[1].plane
       @zvec = sel[1].normal
      elsif(sel[2].kind_of?(Sketchup::Face))
       # planes = sel[2].plane
        @zvec = sel[2].normal
      else
       # planes = [@pts[0],@yvec]
      end
      else
       # planes = [@pts[0],@yvec]
        @zvec = Geom::Vector3d.new(0,0,1)
      end
      vectr = @zvec.axes
      
     @ptt = Array.new
      @ptt[0] = @pts[0] = @ip.position
      @angle = 360.0/@@segment.to_i

      size = view.pixels_to_model(20, @ptt[0])
      pt = @ptt[0].offset(vectr.x, size)
      @pt = @ptt[0].offset(@zvec, size)
      
      trans  = Geom::Transformation.rotation(pt,@zvec,@angle.degrees)
      0.upto(@@segment.to_i){@ptt.push @ptt.last.transform(trans)}
    when 1
    @ptt = Array.new
      @pts[1] = @ip.position
      @yvec =  @pts[1] - @pts[0]
      @length = @pts[0].distance @pts[1]
      
    if(@length > 0.0)
    
      @pts[2] = @pts[0].offset(@yvec, @length/2)

      @ptt[0] = @pts[0]
      trans  = Geom::Transformation.rotation(@pts[2],@zvec,@angle.degrees)
      0.upto(@@segment.to_i){@ptt.push @ptt.last.transform(trans)}

      Sketchup::set_status_text "Diameter:   ", SB_VCB_LABEL  # "Диаметр "
      Sketchup::set_status_text @length.to_s, SB_VCB_VALUE
      end
    end
    view.invalidate
  end
# -------             # -------               # -------  
  def draw(view)
    @drawn = false
    if( @ip.valid?)#&& @ip.display? )
      @ip.draw(view)
      
   case @state
    when 0
     view.line_width = 1
       view.set_color_from_line(@pt,@ptt[0])
        view.draw(GL_LINE_STRIP, @ptt)
         view.draw_points @ptt[0], 6, 2, "DarkViolet"
          @drawn = true
          
   when 1
    if(@length > 0.0)
      view.line_width=1
      view.set_color_from_line(@pts[0],@pts[1])
      view.draw(GL_LINE_STRIP, @pts[0],@pts[1])
      view.draw_points @pts[1], 6, 2, "DarkViolet"
        view.line_width = 2
         view.drawing_color =  "BlueViolet"
          view.draw(GL_LINE_STRIP, @ptt)
          
      @drawn = true
    end
  end
  end
  end 
# -------             # -------               # -------
  def onMouseMove(flags, x, y, view)
    self.set_current_point(x, y, view)
  end
  # -------             # -------               # -------     
 def onLButtonDoubleClick(flags, x, y, view)
   Sketchup.active_model.select_tool(nil)
   end
# -------             # -------               # -------
def onLButtonDown(flags, x, y, view)
    self.set_current_point(x, y, view)
    self.increment_state
    view.lock_inference
  end
# -------             # -------               # -------     
def onLButtonUp(flags, x, y, view)

  end
# -------             # -------               # -------  
def onCancel(flag, view)
    view.invalidate if @drawn
    self.reset
  end
 # -------             # -------               # -------
  def onUserText(text, view)
    begin
      value = text.to_l
    rescue
      UI.beep
      value = nil
      Sketchup::set_status_text "", SB_VCB_VALUE
    end
    return if !value

    case @state
    when 0
      @@segment = text.to_i
      # self.set_current_point(x, y, view)
      # self.increment_state
    when 1
      @length = text.to_l
      self.increment_state
      #self.set_current_point(x, y, view)
    end
  end
# -------             # -------               # -------
end # class
	if( not file_loaded?("krug.rb"))  
	#UI.menu("Plugins").add_item("Круг от грани"){ Sketchup.active_model.select_tool Risuem_krug_otkraya.new }
	UI.menu("Plugins").add_item("Circle from edge"){ Sketchup.active_model.select_tool Risuem_krug_otkraya.new }
#----------------------------------------------------------------------------- By Defisto...xD!
	toolbar = UI::Toolbar.new("Circle by Diameter")
	path = File.dirname(__FILE__) + "/krug_Icons/"
	toolbar.show
#----------------------------------------------------------------------------- By Defisto...xD!
	cmd1 = UI::Command.new("Risuem_krug_otkraya.new" ) { Sketchup.active_model.select_tool Risuem_krug_otkraya.new }
	cmd1.small_icon = path + "CircleByDiameter_16.png"
	cmd1.large_icon = path + "CircleByDiameter_24.png"
	cmd1.tooltip = "Circle by Diameter (2 Points)"
	cmd1.status_bar_text ="Draw a Circle by its Diameter through the Designation of 2 Points"
	toolbar.add_item(cmd1)
#----------------------------------------------------------------------------- By Defisto...xD!
	UI.add_context_menu_handler do | menu |
	sel = Sketchup.active_model.selection
	if(sel[0].typename=="Edge")
	if(sel[0].curve)
		menu.add_separator
		menu.add_item("Add face circle"){ sel.each{|edg| edg.find_faces if edg.is_a? Sketchup::Edge} }
		end#if
	  end
   end
end
# ------------------------ # 
file_loaded("krug.rb")
# =*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*= #